/*
 * trace.c
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1996/01/30 22:42:20 $
 */

#include "platform.h"
#include "xk_debug.h"
#include "compose.h"

#ifdef XK_TRACE_LOCKING
#undef XK_TRACE_LOCKING
#endif

#ifdef XK_TRACE_LOCKING
Semaphore lock;
#endif

void
xTraceLock(void)
{
#ifdef XK_TRACE_LOCKING
  mutexLock( &lock );
#endif
}

void
xTraceUnlock(void)
{
#ifdef XK_TRACE_LOCKING
  mutexUnlock( &lock );
#endif
}

 

void
xTraceInit(void)
{
#ifdef XK_TRACE_LOCKING
  abort();
  mutexInit(&lock);
#endif
  initTraceLevels();
}

