/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_lifo.c,v $
 *
 * HISTORY
 * $Log: scout_lifo.c,v $
 * Revision 1.5  1996/01/30  22:49:51  slm
 * Updated copyright and version.
 *
 * Revision 1.4.1.1  1994/12/02  23:53:05  hkaram
 * New branch
 *
 * Revision 1.4  1994/06/11  00:02:30  menze
 * Added copyright notice
 *
 * Revision 1.3  1994/05/14  23:54:33  davidm
 * (scout_lifo_push): assertion added.
 *
 * Revision 1.2  1994/04/18  23:42:31  davidm
 * (scout_lifo_pop): popping an empty stack now returns 0 as it should.
 *
 * Revision 1.1  1994/04/18  23:35:02  davidm
 * Initial revision
 */
/*
 * Concurrent single-reader/single-writer stack package.
 */
#include "scout_assert.h"
#include "scout_lifo.h"
#include "scout_sync_arch.h"

typedef struct scout_lifo_link Link;


void
scout_lifo_init(Scout_LIFO *s)
{
    s->head = 0;
} /* scout_lifo_init */


void
scout_lifo_push(Scout_LIFO *s, void *element)
{
    Link *el = element;

    scout_assert(element);
    ScoutAtomicSequence(el->next = s->head; s->head = el);
} /* scout_lifo_push */


void*
scout_lifo_pop(Scout_LIFO *s)
{
    Link *el;

    ScoutAtomicSequence(el = s->head;
			if (el) {
			    s->head = el->next;
			} else {
			    s->head = 0;
			} /* if */);
    return el;
} /* scout_lifo_pop */

			/*** end of scout_lifo.c ***/
